Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Class StartTagBuffer

    java.lang.Object
      net.sf.saxon.event.SequenceReceiver
          net.sf.saxon.event.ProxyReceiver
              net.sf.saxon.event.StartTagBuffer

All Implemented Interfaces:
  NamespaceResolver, Receiver, javax.xml.transform.Result

Direct Known Subclasses:
  IDFilter

public class StartTagBuffer
extends ProxyReceiver
implements NamespaceResolver

StartTagBuffer is a ProxyReceiver that buffers attributes and namespace events within a start tag. It maintains details of the namespace context, and a full set of attribute information, on behalf of other filters that need access to namespace information or need to process attributes in arbitrary order.

Field Summary

Fields inherited from class net.sf.saxon.event.ProxyReceiver
`nextReceiver, systemId`

Fields inherited from class net.sf.saxon.event.SequenceReceiver
`pipelineConfiguration, previousAtomic`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`StartTagBuffer()`

Method Summary
`void` | `attribute(int nameCode, int typeCode, java.lang.CharSequence value, int locationId, int properties)` Notify an attribute.
`protected void` | `declareAllNamespaces()`
`protected void` | `declareNamespacesForStartElement()`
`void` | `endElement()` endElement: Discard the namespaces declared on this element.
`java.lang.String` | `getAttribute(int nameCode)` Get the value of the current attribute with a given nameCode
`int` | `getElementNameCode()` Get the name of the current element
`protected short` | `getURICode(short prefixCode)` Get the URI code corresponding to a given prefix code, by searching the in-scope namespaces.
`java.lang.String` | `getURIForPrefix(java.lang.String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
`boolean` | `hasAttributes()` Determine if the current element has any attributes
`java.util.Iterator` | `iteratePrefixes()` Get an iterator over all the prefixes declared in this namespace context.
`void` | `namespace(int namespaceCode, int properties)` Notify a namespace.
`void` | `setPipelineConfiguration(PipelineConfiguration config)` Set the pipeline configuration
`void` | `startContent()` startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements
`void` | `startElement(int nameCode, int typeCode, int locationId, int properties)` startElement
`protected void` | `undeclareNamespacesForElement()`

Methods inherited from class net.sf.saxon.event.ProxyReceiver
`characters, close, comment, endDocument, getConfiguration, getDocumentLocator, getNamePool, getSystemId, getUnderlyingReceiver, open, processingInstruction, setSystemId, setUnderlyingReceiver, setUnparsedEntity, startDocument`

Methods inherited from class net.sf.saxon.event.SequenceReceiver
`append, getPipelineConfiguration`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### StartTagBuffer

    public StartTagBuffer()

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration config)

  Description copied from interface: `Receiver`
  Set the pipeline configuration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Overrides:
    `setPipelineConfiguration` in class `ProxyReceiver`

### startElement

    public void startElement(int nameCode,
                             int typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  startElement

  Specified by:
    `startElement` in interface `Receiver`
  Overrides:
    `startElement` in class `ProxyReceiver`
  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool.
    `properties` - properties of the element node
  Throws:
    `XPathException`

### namespace

    public void namespace(int namespaceCode,
                          int properties)
                   throws XPathException

  Description copied from class: `ProxyReceiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Specified by:
    `namespace` in interface `Receiver`
  Overrides:
    `namespace` in class `ProxyReceiver`
  Parameters:
    `namespaceCode` - an integer: the top half is a prefix code, the bottom half a URI code. These may be translated into an actual prefix and URI using the name pool. A prefix code of zero represents the empty prefix (that is, the default namespace). A URI code of zero represents a URI of "", that is, a namespace undeclaration.
  Throws:
    `XPathException`

### attribute

    public void attribute(int nameCode,
                          int typeCode,
                          java.lang.CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Specified by:
    `attribute` in interface `Receiver`
  Overrides:
    `attribute` in class `ProxyReceiver`
  Parameters:
    `nameCode` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `properties` - Bit significant value. The following bits are defined:
    DISABLE_ESCAPING
  Disable escaping for this attribute
    NO_SPECIAL_CHARACTERS
  Attribute value contains no special characters
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException`

### startContent

    public void startContent()
                      throws XPathException

  startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements

  Specified by:
    `startContent` in interface `Receiver`
  Overrides:
    `startContent` in class `ProxyReceiver`
  Throws:
    `XPathException`

### declareNamespacesForStartElement

    protected void declareNamespacesForStartElement()
                                             throws XPathException

  Throws:
    `XPathException`

### declareAllNamespaces

    protected void declareAllNamespaces()
                                 throws XPathException

  Throws:
    `XPathException`

### endElement

    public void endElement()
                    throws XPathException

  endElement: Discard the namespaces declared on this element.

  Specified by:
    `endElement` in interface `Receiver`
  Overrides:
    `endElement` in class `ProxyReceiver`
  Throws:
    `XPathException`

### undeclareNamespacesForElement

    protected void undeclareNamespacesForElement()

### getElementNameCode

    public int getElementNameCode()

  Get the name of the current element

### hasAttributes

    public boolean hasAttributes()

  Determine if the current element has any attributes

### getAttribute

    public java.lang.String getAttribute(int nameCode)

  Get the value of the current attribute with a given nameCode

  Returns:
    the attribute value, or null if the attribute is not present

### getURICode

    protected short getURICode(short prefixCode)

  Get the URI code corresponding to a given prefix code, by searching the in-scope namespaces. This is a service provided to subclasses.

  Parameters:
    `prefixCode` - the 16-bit prefix code required
  Returns:
    the 16-bit URI code, or -1 if the prefix is not bound to any namespace

### getURIForPrefix

    public java.lang.String getURIForPrefix(java.lang.String prefix,
                                            boolean useDefault)

  Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope.

  Specified by:
    `getURIForPrefix` in interface `NamespaceResolver`
  Parameters:
    `prefix` - the namespace prefix
    `useDefault` - true if the default namespace is to be used when the prefix is ""
  Returns:
    the uri for the namespace, or null if the prefix is not in scope

### iteratePrefixes

    public java.util.Iterator iteratePrefixes()

  Get an iterator over all the prefixes declared in this namespace context. This will include the default namespace (prefix="") and the XML namespace where appropriate

  Specified by:
    `iteratePrefixes` in interface `NamespaceResolver`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD